package com.io.yutian.aulib.nbt;

import net.minecraft.nbt.NBTTagCompound;
import org.bukkit.craftbukkit.v1_18_R2.inventory.CraftItemStack;
import org.bukkit.inventory.ItemStack;

import java.util.function.Consumer;

public class NBTItemStack {

    private ItemStack originalItemStack;
    private net.minecraft.world.item.ItemStack nmsItemStack;

    protected ItemStack resultItemStack;

    public NBTItemStack(ItemStack itemStack) {
        this.originalItemStack = itemStack;
        this.nmsItemStack = CraftItemStack.asNMSCopy(itemStack);
    }

    public NBTCompound getTag() {
        NBTTagCompound tag = nmsItemStack.u();
        if (tag == null) {
            tag = new NBTTagCompound();
        }
        return (NBTCompound) INBT.as(tag);
    }

    public void editTag(Consumer<NBTCompound> consumer) {
        NBTCompound tag = getTag();
        consumer.accept(tag);
        setTag(tag);
    }

    public void setTag(NBTCompound nbtCompound) {
        nmsItemStack.c((NBTTagCompound) INBT.asNMS(nbtCompound));
        resultItemStack = CraftItemStack.asBukkitCopy(nmsItemStack);
    }

    public ItemStack getOriginalItemStack() {
        return originalItemStack;
    }

    public ItemStack getItemStack() {
        return resultItemStack;
    }

    public net.minecraft.world.item.ItemStack getNMSItemStack() {
        return nmsItemStack;
    }

    public static NBTItemStack build(ItemStack itemStack) {
        return new NBTItemStack(itemStack);
    }

    public static NBTItemStack build(NBTCompound nbtCompound) {
        net.minecraft.world.item.ItemStack nmsItemStack = net.minecraft.world.item.ItemStack.a((NBTTagCompound) INBT.asNMS(nbtCompound));
        return new NBTItemStack(CraftItemStack.asBukkitCopy(nmsItemStack));
    }

}
